hiedb-0.6.0.0: Generates a references DB from .hie files

Safe Haskell | None
Language | Haskell2010

HieDb.Run

# Documentation

hiedbMain :: LibDir -> IO () #

data Options #

Constructors

Options |
Fields database :: FilePath trace :: Bool quiet :: Bool colour :: Bool context :: Maybe Natural reindex :: Bool keepMissing :: Bool srcBaseDir :: Maybe FilePath skipIndexingOptions :: SkipOptions

data Command #

Constructors

Init |
Index [FilePath] |
NameRefs String (Maybe ModuleName) (Maybe Unit) |
TypeRefs String (Maybe ModuleName) (Maybe Unit) |
NameDef String (Maybe ModuleName) (Maybe Unit) |
TypeDef String (Maybe ModuleName) (Maybe Unit) |
Cat HieTarget |
Ls |
LsExports (Maybe ModuleName) |
Rm [HieTarget] |
ModuleUIDs ModuleName |
LookupHieFile ModuleName (Maybe Unit) |
RefsAtPoint HieTarget (Int, Int) (Maybe (Int, Int)) |
TypesAtPoint HieTarget (Int, Int) (Maybe (Int, Int)) |
DefsAtPoint HieTarget (Int, Int) (Maybe (Int, Int)) |
InfoAtPoint HieTarget (Int, Int) (Maybe (Int, Int)) |
RefGraph |
Dump FilePath |
Reachable [Symbol] |
Unreachable [Symbol] |
Html [Symbol] |
GCTypeNames |

progParseInfo :: FilePath -> Bool -> ParserInfo (Options, Command) #

progParser :: FilePath -> Bool -> Parser (Options, Command) #

optParser :: FilePath -> Bool -> Parser Options #

cmdParser :: Parser Command #

posParser :: Char -> Parser (Int, Int) #

maybeUnitId :: Parser (Maybe Unit) #

symbolParser :: Parser Symbol #

moduleNameParser :: Parser ModuleName #

hieTarget :: Parser HieTarget #

progress :: Handle -> Int -> Int -> (FilePath -> DbMonad Bool) -> FilePath -> DbMonad Bool #

doIndex :: HieDb -> Options -> Handle -> [FilePath] -> IO () #

runCommand :: LibDir -> Options -> Command -> IO () #

printInfo :: DynFlags -> NodeInfo IfaceType -> RealSrcSpan -> IO () #

hieFileCommand :: HieDb -> Options -> HieTarget -> (HieFile -> IO a) -> IO a #

reportAmbiguousErr :: Options -> Either HieDbErr a -> IO a #

showHieDbErr :: Options -> HieDbErr -> String #

reportRefSpans :: Options -> [(Module, (Int, Int), (Int, Int), Maybe (Either FilePath ByteString))] -> IO () #

reportRefs :: Options -> [Res RefRow] -> IO () #

colouredPP :: Color -> (a -> String) -> Options -> a -> String #

ppName :: Options -> OccName -> String #

ppMod :: Options -> ModuleName -> String #

ppUnit :: Options -> Unit -> String #

ppSpan :: Options -> (Int, Int) -> String #